#include <map>
#include <algorithm>
#include <string>
#include <iostream>
using namespace std;

int main() {
    int n;
    cin >> n;
        
    map<string, int> logi;

    // siin hoiame seni leitud suurimat esinemissagedust. Kuna lesande tingimustes on
    //vhemalt 1 kombinatsioon olemas, vib selle panna heks.
    int maxN = -1;
    string kursused[5]; //siin hoiame he inimese vetud kursusi

    for (int i = 0; i < n; i++) {
        cin >> kursused[0] >> kursused[1] >> kursused[2] >> kursused[3] >> kursused[4];
        sort(kursused, kursused + 5); //sorteerime kursused kasvavas jrjekorras

        string voti;
        for (int j = 0; j < 5; j++) {
            voti += kursused[j]; // hendame kursuste numbrid heks stringiks
        }
        // kui sellist vtit pole (sellist kombinatsiooni ei esine)
        if (!logi.count(voti)) {
            logi[voti] = 1; // lisame selle vrtusega 1.
            maxN = max(maxN, 1);
        }
        else { // kui vti on
            int m = logi[voti] + 1; // suurendame kombinatsiooni korduste arvu
            logi[voti] = m; // ja muudame vastavaks
            // kui on suurem korduste arv, kui senine maksimum, muudame maksimumi.
            maxN = max(maxN, m);
        }
    }

    map<string, int>::iterator it;
    for (it = logi.begin(); it != logi.end(); it++) { // kime mapi lbi
        if (it->second == maxN) // kui on suurim korduste arv
            for (int i = 0; i < 13; i += 3) {
                // eraldame vtmest kursuste numbrid ja vljastame need.
                cout << it->first.substr(i, 3) << " ";
            }
        cout << endl;
    }

    return 0;
}